<?php

################################################################################
# @Name : ticket_category_db.php
# @Description : send category of current selected type
# @Create : 10/02/2021





################################################################################


//security check
if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') 
{
    //db connection
    require('../connect.php');

    //switch SQL MODE to allow empty values
    $db->exec('SET sql_mode = ""');

    //load parameters table
    $qry=$db->prepare("SELECT * FROM `tparameters`");
    $qry->execute();
    $rparameters=$qry->fetch();
    $qry->closeCursor();

    //display error parameter
    if($rparameters['debug']) {
        ini_set('display_errors', 'On');
        ini_set('display_startup_errors', 'On');
        ini_set('html_errors', 'On');
        error_reporting(E_ALL);
    } else {
        ini_set('display_errors', 'Off');
        ini_set('display_startup_errors', 'Off');
        ini_set('html_errors', 'Off');
        error_reporting(E_ALL & ~E_DEPRECATED & ~E_STRICT);
    }

    //init string
    if(!isset($_POST['TypeId'])) $_POST['TypeId'] = '';
    $type_arr=array();

    //secure string
    $_POST['TypeId']=htmlspecialchars($_POST['TypeId'], ENT_QUOTES, 'UTF-8');

    //put each db value in array 
    $qry=$db->prepare("SELECT `id`,`name` FROM `tcategory` WHERE `id_type`=:id ORDER BY `name`");
    $qry->execute(array('id' => $_POST['TypeId']));
    while($type=$qry->fetch()) 
    {
       $type_arr[] = array("id" => $type['id'], "name" => $type['name']);
    }
    $qry->closeCursor();
    //return array
    echo json_encode($type_arr);

    //close database access
	$db = null;
} else {
	echo json_encode(array("status" => "failed"));
}
?>